/* sf11r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__11 = 11;

real sf11r_c(real *x, integer *l, integer *ierr)
{
    /* Initialized data */

    static real one = 1.f;
    static real g[2] = { -221.6787f,17002.1f };
    static real pp[10] = { .06982646f,6.943429f,101.6245f,519.0226f,1207.12f,
            1430.398f,900.5826f,298.6452f,48.33008f,2.958172f };
    static real qq[8] = { 30.17104f,228.115f,673.0124f,924.6058f,638.5721f,
            224.4323f,37.67672f,2.36028f };
    static real zero = 0.f;
    static real sys059 = 3.4e38f;
    static real sys061 = 1.2e-38f;
    static real xmax = 44.36f;
    static real sys073 = 3.743392e-23f;
    static real p[5] = { .1203177f,24.99784f,1797.135f,44333.31f,179847.3f };
    static real q[4] = { .25f,-70.35979f,9316.075f,-553734.4f };
    static real f[5] = { .002107619f,.4076347f,30.92138f,951.7919f,8501.049f };

    /* System generated locals */
    real ret_val;

    /* Builtin functions */
    double exp(doublereal), log(doublereal), sqrt(doublereal);

    /* Local variables */
    static real sumf, sumg, sump, sumq, a;
    static integer i__;
    extern /* Subroutine */ int utsf10_c(integer *, integer *);
    static real xx;

    *ierr = 0;
    if (*x < sys061) {
        goto L8;
    }
    a = one;
    if (*l != 1 && *l != 2) {
        goto L10;
    }
    switch (*l) {
        case 1:  goto L1;
        case 2:  goto L2;
    }
L1:
    if (*x > xmax) {
        goto L9;
    }
    if (*x <= one) {
        goto L3;
    }
    a = (real)exp((real)(-(*x)));
    goto L5;
L2:
    if (*x > one) {
        goto L5;
    }
    a = (real)exp(*x);
L3:
    if (*x < sys073) {
        goto L4;
    }
    xx = *x * *x;
    sump = ((((p[0] * xx + p[1]) * xx + p[2]) * xx + p[3]) * xx + p[4]) * xx 
            + q[3];
    sumq = ((q[0] * xx + q[1]) * xx + q[2]) * xx + q[3];
    sumf = (((f[0] * xx + f[1]) * xx + f[2]) * xx + f[3]) * xx + f[4];
    sumg = (xx + g[0]) * xx + g[1];
    ret_val = (xx * (real)log(*x) * sumf / sumg + sump / sumq) / *x * a;
    goto L12;
L4:
    ret_val = one / *x;
    goto L12;
L5:
    xx = one / *x;
    sump = pp[0];
    for (i__ = 2; i__ <= 10; ++i__) {
        sump = sump * xx + pp[i__ - 1];
/* L6: */
    }
    sumq = xx;
    for (i__ = 1; i__ <= 7; ++i__) {
        sumq = (sumq + qq[i__ - 1]) * xx;
/* L7: */
    }
    sumq += qq[7];
    ret_val = a * sump / sumq / (real)sqrt(*x);
    goto L12;
L8:
    *ierr = 66;
    ret_val = sys059;
    goto L11;
L9:
    *ierr = 67;
    ret_val = zero;
    goto L11;
L10:
    ret_val = sys059;
    *ierr = 65;
L11:
    utsf10_c(ierr, &c__11);
L12:
    return ret_val;
} /* sf11r_c */
